#include <iostream>
#include <cmath>
#include <time.h>
using namespace std;

double normal_variate (void);//compute standard normal samples


void compute_fundamental (double **pri_matrix, int num_obs, double r, double *lamda_F_1)
{
	double r_s,D;
	

	 D=1.0;//expected edivided

	  r_s = (1000-pri_matrix[0][num_obs-1]+D)/pri_matrix[0][num_obs-1]-r;
	
	   lamda_F_1[0]=0.31831*(atan(0.25*r_s)+1.5707963);
	  
	   lamda_F_1[1]=1-lamda_F_1[0];
		
}



void compute_trend (double *market_return, int num_obs,  double r, double *lamda_T_1)
{
	
	double r_s,total;
	total=0;
		
	for(int j = 0; j<num_obs-1; j++)
	    total += market_return[j];	  

		
    r_s=total/(num_obs-1);   
    r_s = r_s-1-r;

		    	
	lamda_T_1[0]=0.31831*(atan((num_obs-1)*r_s)+1.5707963);
    lamda_T_1[1]=1-lamda_T_1[0];

}


void compute_noise (double& noise_intensity, double *lamda_N_1)
{
 
   noise_intensity=0.97*noise_intensity+0.2*normal_variate();
   lamda_N_1[0]=0.31831*(atan(noise_intensity)+1.5707963);
   lamda_N_1[1] = 1- lamda_N_1[0];


}
